import nodeVersionAlias from"node-version-alias";

import{getError}from"./error.js";
import{findVersion}from"./find.js";
import{getOpts}from"./options.js";



const preferredNodeVersion=async(opts)=>{
const{cwd,globalOpt,nodeVersionAliasOpts}=getOpts(opts);
const{filePath,envVariable,rawVersion}=await findVersion(
cwd,
globalOpt
);

if(rawVersion===undefined){
return{}
}

try{
const version=await nodeVersionAlias(rawVersion,nodeVersionAliasOpts);
return{filePath,envVariable,rawVersion,version}
}catch(error){
throw getError(error,filePath,envVariable)
}
};

export default preferredNodeVersion;